"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable @typescript-eslint/explicit-function-return-type */
/* eslint-disable no-underscore-dangle */
/* eslint-disable @typescript-eslint/unbound-method */
const base_1 = require("@jupyter-widgets/base");
require("regular-table");
require("regular-table/dist/css/material.css");
// Import the CSS
require("../css/widget.css");
class RegularTableView extends base_1.DOMWidgetView {
    constructor() {
        super(...arguments);
        this.resolve = undefined;
        this.reject = undefined;
    }
    render() {
        this.model.on("msg:custom", this._handle_msg, this);
        this.el.classList.add("ipyregulartable");
        this.el.style.height = `${this.model.get("height")}px`;
        this.model.on("change:height", this._handle_height, this);
        // this.model.on("change:_data", this._handle_data, this);
        this.model.on("change:_editable", this._handle_editable, this);
        this.displayed.then(() => {
            this._render();
            this.table.draw();
        });
    }
    _handle_data() {
        if (this.resolve !== undefined && this.model.get("_data")) {
            this.resolve(this.model.get("_data"));
            this.resolve = undefined;
            this.reject = undefined;
        }
        else {
            this.reject();
            this.resolve = undefined;
            this.reject = undefined;
        }
    }
    _handle_editable() {
        if (this.isEditable !== undefined) {
            this.isEditable(this.model.get("_editable"));
        }
    }
    _handle_height() {
        this.el.style.height = `${this.model.get("height")}px`;
    }
    _handle_msg(msg) {
        if (msg.type === "draw") {
            this._handle_draw();
        }
        else if (msg.type === "data") {
            this._handle_data();
        }
    }
    _handle_draw() {
        // TODO
        this.table.draw();
    }
    _render() {
        // render a regular-table
        this.table = document.createElement("regular-table");
        this.el.appendChild(this.table);
        // hook data model into python
        this.table.setDataListener((x0, y0, x1, y1) => new Promise((resolve, reject) => {
            if (this.resolve !== undefined) {
                // existing outstanding promise
                this.reject();
                this.resolve = undefined;
                this.reject = undefined;
            }
            // send event to python
            this.resolve = resolve;
            this.reject = reject;
            this.send({ event: "getDataSlice", value: [x0, y0, x1, y1] });
        }));
        // hook in click events
        this.table.addEventListener("click", (event) => {
            const meta = this.table.getMeta(event.target);
            if (meta) {
                this.send({ event: "click", value: [meta.x, meta.y] });
            }
        });
        // hook edit events into python
        this.table.addEventListener("click", (event) => {
            const meta = this.table.getMeta(event.target);
            if (meta) {
                return new Promise((resolve) => {
                    // send event to python
                    this.send({ event: "getEditable", value: [meta.x, meta.y] });
                    this.isEditable = (target = event.target) => {
                        if (this.model.get("_editable") === true) {
                            target.setAttribute("contenteditable", "true");
                        }
                        resolve();
                    };
                });
            }
        });
    }
}
exports.RegularTableView = RegularTableView;
//# sourceMappingURL=view.js.map